angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'starter.directives', 'ngCordova', 'ngStorage', 'ngMessages'])

.run(function ($ionicPlatform, $rootScope, $localStorage, NetworkTools, EmailTools, LocationTools, UpdateTools) {

    $rootScope.$storage = $localStorage.$default({
        currentVersion: 1
    });
    
    if ($rootScope.$storage.wifispots == null) {
        $rootScope.$storage.wifispots = wifispots.data;
    }

  $ionicPlatform.ready(function() {
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
        StatusBar.styleLightContent();
    }

      // if a connection is available, check for updates and send pending mail
    if (NetworkTools.isOnline()) {
        function rCallback(result, index) {
            if (result == 'success') $rootScope.$storage.pendingposts = null; //.splice(i, 1);
        };

        if ($rootScope.$storage.pendingposts == null) $rootScope.$storage.pendingposts = [];
        var i = $rootScope.$storage.pendingposts.length;
        while (i--) {
            EmailTools.$send($rootScope.$storage.pendingposts[i], rCallback, i);
        }

        UpdateTools.$updateNow(null, null);
    }

    LocationTools.startWatch();

    document.addEventListener("pause", LocationTools.stopWatch, false);
    document.addEventListener("resume", LocationTools.startWatch, false);
  });
})

.config(function($stateProvider, $urlRouterProvider) {
    $stateProvider

    // setup an abstract state for the tabs directive
      .state('tab', {
      url: '/tab',
      abstract: true,
      templateUrl: 'templates/tabs.html'
    })
      .state('tab.about', {
          url: '/about',
          views: {
              'tab-about': {
                  templateUrl: 'templates/tab-about.html',
                  controller: 'AboutCtrl'
              }
          }
      })
      .state('tab.about-contact', {
          url: '/about/contact',
          views: {
              'tab-about': {
                  templateUrl: 'templates/about-contact.html',
                  controller: 'AboutContactCtrl'
              }
          }
      })

      .state('tab.map', {
          url: '/map',
          views: {
              'tab-map': {
                  templateUrl: 'templates/tab-map.html',
                  controller: 'MapCtrl'
              }
          }
      })

      .state('tab.nearby', {
          url: '/nearby',
          views: {
              'tab-nearby': {
                  templateUrl: 'templates/tab-nearby.html',
                  controller: 'NearbyCtrl'
              }
          }
      })
      .state('tab.spot-detail', {
          url: '/hotspots/:spotId',
          views: {
              'tab-nearby': {
                  templateUrl: 'templates/spot-detail.html',
                  controller: 'SpotDetailCtrl'
              }
          }
      });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/nearby');

});
